summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDamien Miller <djm@cvs.openbsd.org>2022-06-03 04:31:55 +0000
committerDamien Miller <djm@cvs.openbsd.org>2022-06-03 04:31:55 +0000
commit6aee16d5c88aa4801b085f47f5f6dd936b56dbb0 (patch)
treee7c2d4a27f6823eb0364b8260a9bdf127fd8af2a
parent547d116666458b99b29e173f3fd3e03a6ea60f9c (diff)
test setenv in both client and server, test first-match-wins too
-rw-r--r--regress/usr.bin/ssh/envpass.sh67
-rw-r--r--regress/usr.bin/ssh/multiplex.sh16
2 files changed, 79 insertions, 4 deletions
diff --git a/regress/usr.bin/ssh/envpass.sh b/regress/usr.bin/ssh/envpass.sh
index af7eafe3d16..cb104686bb7 100644
--- a/regress/usr.bin/ssh/envpass.sh
+++ b/regress/usr.bin/ssh/envpass.sh
@@ -1,4 +1,4 @@
-# $OpenBSD: envpass.sh,v 1.4 2005/03/04 08:48:46 djm Exp $
+# $OpenBSD: envpass.sh,v 1.5 2022/06/03 04:31:54 djm Exp $
# Placed in the Public Domain.
tid="environment passing"
@@ -11,6 +11,7 @@ Host test-sendenv-confparse-bug
SendEnv *
EOF
cat $OBJ/ssh_proxy >> $OBJ/ssh_proxy_envpass
+cp $OBJ/sshd_proxy $OBJ/sshd_proxy_bak
trace "pass env, don't accept"
verbose "test $tid: pass env, don't accept"
@@ -23,6 +24,18 @@ if [ $r -ne 0 ]; then
fail "environment found"
fi
+trace "setenv, don't accept"
+verbose "test $tid: setenv, don't accept"
+${SSH} -oSendEnv="*" -F $OBJ/ssh_proxy_envpass -oSetEnv="_TEST_ENV=blah" \
+ otherhost \
+ sh << 'EOF'
+ test -z "$_TEST_ENV"
+EOF
+r=$?
+if [ $r -ne 0 ]; then
+ fail "environment found"
+fi
+
trace "don't pass env, accept"
verbose "test $tid: don't pass env, accept"
_XXX_TEST_A=1 _XXX_TEST_B=2 ${SSH} -F $OBJ/ssh_proxy_envpass otherhost \
@@ -57,4 +70,56 @@ if [ $r -ne 0 ]; then
fail "environment not found"
fi
+trace "setenv, accept"
+verbose "test $tid: setenv, accept"
+${SSH} -F $OBJ/ssh_proxy_envpass \
+ -oSetEnv="_XXX_TEST_A=1 _XXX_TEST_B=2" otherhost \
+ sh << 'EOF'
+ test X"$_XXX_TEST_A" = X"1" -a X"$_XXX_TEST_B" = X"2"
+EOF
+r=$?
+if [ $r -ne 0 ]; then
+ fail "environment not found"
+fi
+trace "setenv, first match wins"
+verbose "test $tid: setenv, first match wins"
+${SSH} -F $OBJ/ssh_proxy_envpass \
+ -oSetEnv="_XXX_TEST_A=1 _XXX_TEST_A=11 _XXX_TEST_B=2" otherhost \
+ sh << 'EOF'
+ test X"$_XXX_TEST_A" = X"1" -a X"$_XXX_TEST_B" = X"2"
+EOF
+r=$?
+if [ $r -ne 0 ]; then
+ fail "environment not found"
+fi
+
+trace "server setenv wins"
+verbose "test $tid: server setenv wins"
+cp $OBJ/sshd_proxy_bak $OBJ/sshd_proxy
+echo "SetEnv _XXX_TEST_A=23" >> $OBJ/sshd_proxy
+${SSH} -F $OBJ/ssh_proxy_envpass \
+ -oSetEnv="_XXX_TEST_A=1 _XXX_TEST_B=2" otherhost \
+ sh << 'EOF'
+ test X"$_XXX_TEST_A" = X"23" -a X"$_XXX_TEST_B" = X"2"
+EOF
+r=$?
+if [ $r -ne 0 ]; then
+ fail "environment not found"
+fi
+
+trace "server setenv first match wins"
+verbose "test $tid: server setenv wins"
+cp $OBJ/sshd_proxy_bak $OBJ/sshd_proxy
+echo "SetEnv _XXX_TEST_A=23 _XXX_TEST_A=42" >> $OBJ/sshd_proxy
+${SSH} -F $OBJ/ssh_proxy_envpass \
+ -oSetEnv="_XXX_TEST_A=1 _XXX_TEST_B=2" otherhost \
+ sh << 'EOF'
+ test X"$_XXX_TEST_A" = X"23" -a X"$_XXX_TEST_B" = X"2"
+EOF
+r=$?
+if [ $r -ne 0 ]; then
+ fail "environment not found"
+fi
+
+
rm -f $OBJ/ssh_proxy_envpass
diff --git a/regress/usr.bin/ssh/multiplex.sh b/regress/usr.bin/ssh/multiplex.sh
index 36e40182f49..8982363c6d3 100644
--- a/regress/usr.bin/ssh/multiplex.sh
+++ b/regress/usr.bin/ssh/multiplex.sh
@@ -1,4 +1,4 @@
-# $OpenBSD: multiplex.sh,v 1.33 2020/06/24 15:16:23 markus Exp $
+# $OpenBSD: multiplex.sh,v 1.34 2022/06/03 04:31:54 djm Exp $
# Placed in the Public Domain.
CTL=$OBJ/ctl-sock
@@ -31,8 +31,8 @@ start_mux_master()
start_mux_master
-verbose "test $tid: envpass"
-trace "env passing over multiplexed connection"
+verbose "test $tid: setenv"
+trace "setenv over multiplexed connection"
_XXX_TEST=blah ${SSH} -F $OBJ/ssh_config -oSendEnv="_XXX_TEST" -S$CTL otherhost sh << 'EOF'
test X"$_XXX_TEST" = X"blah"
EOF
@@ -40,6 +40,16 @@ if [ $? -ne 0 ]; then
fail "environment not found"
fi
+verbose "test $tid: envpass"
+trace "env passing over multiplexed connection"
+${SSH} -F $OBJ/ssh_config -oSetEnv="_XXX_TEST=foo" -S$CTL otherhost sh << 'EOF'
+ test X"$_XXX_TEST" = X"foo"
+EOF
+if [ $? -ne 0 ]; then
+ fail "environment not found"
+fi
+
+
verbose "test $tid: transfer"
rm -f ${COPY}
trace "ssh transfer over multiplexed connection and check result"